///home/berryj/link/bin/genMethods "-g" "-t" "Edge*" "-h" "List" "-I" "LINK/basic/List.h" "-I" "LINK/graph/Edge.h" "-d" "graph" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/basic/List.h>

#include <LINK/graph/Edge.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/ListWrapper.h>


typedef Edge* _Edge_;
typedef List<Edge* > _List_Edge__;
static List<Edge* > s__List_Edge__;

#define _List_Edge__DATA(x) ((List<Edge* >*) (EXTDATA(x)))
#define _List_Edge__IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<List<Edge* > >::type))
#define _List_Edge__ISNT_DATA(x) (!_List_Edge__IS_DATA(x))

#define _List_Edge__CXX_DATA(x) (*(List<Edge* >*) (EXTDATA(VAL(x))))
#define _List_Edge__CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<List<Edge* > >::type))
#define _List_Edge__CXX_ISNT_DATA(x) (!_List_Edge__CXX_IS_DATA(x))


PRIMITIVE STk_init__List_Edge__()
{
	Wrapper<_List_Edge__>::type = STk_new_CXXwrapper_id(
			Wrapper<_List_Edge__>::name, 
			"",
			(void (*)(SCM x, SCM port, int mode))
			ListWrapper<_Edge_>::displayTypedList,
			(void (*)(SCM x))ListWrapper<_Edge_>::markTypedList,
			(void (*)(SCM x))ListWrapper<_Edge_>::freeTypedList);
	Tcl_InitHashTable(&Register<_List_Edge__>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_List_Edge__Methods(void);

PRIMITIVE STk_init_methods__List_Edge__()
{
	STk_add_new_cpp_primitive("List-Edge-make", tc_subr_0, 
	(PRIMITIVE (*)(...))  ListWrapper<_Edge_>::makeLinkList);
	STk_add_new_cpp_primitive("List-Edge?", tc_subr_1, 
	(PRIMITIVE (*)(...))  ListWrapper<_Edge_>::linkListP);
	STk_add_new_cpp_primitive("list->List-Edge", tc_subr_1, 
	(PRIMITIVE (*)(...))  ListWrapper<_Edge_>::stkList2LinkList);
	STk_add_new_cpp_primitive("List-Edge->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  ListWrapper<_Edge_>::linkList2STkList);
	genExtra_List_Edge__Methods();
	return UNDEFINED;
}
